<template>
  <SinglePane class="notice">
    <ObFunctionalPanel
        :columns="columns"
        :show-group="false"
        :show-sort="false"
        @search="onSearch"
    />
    <div class="notice-title">уведомления о событии в системе</div>
    <ObCollapse :accordion="true" value="collapse-0">
      <ObCollapseItem
        v-for="(notice, index) in notices"
        :key="notice.uuid"
        :name="`collapse-${index}`"
      >
        <div slot="title">
          {{notice.title}}
          <span class="ob-collapse-title _recipients">Получателей: {{notice.counter ? notice.counter.length : 0}}</span>
          <span class="ob-collapse-title _subscriptions">Подписки на эти уведомления</span>
        </div>
        <div>
          <template v-for="setting in notice.settings">
            <UserForm
              :key="setting.uuid"
              :system-users="systemUsers"
              :setting="setting"
              :setting-type="setting.settingType"
              :key-word="keyWord"
              @update="updateSetting(setting)"
              @remove="onRemoveSettings(setting)"
            />
          </template>
          <div class="notice-add-btn">
            <ObMenuDropdown
              :items="[{
                title: 'Пользователи системы',
                method: () => addUserForm(index, notice.uuid, 'USER')
              },
             /* {
                title: 'Внешний получатель',
               method: () => addUserForm(index, notice.uuid, 'EXTERNAL_RECIPIENT')
              }*/
              ]"
              :is-arrow="false"
              :isNoneButtonStyle="true"
              label="Добавить получателя уведомлений"
              icon="plus"
            >
              <div slot="button">
                <i class="icon plus notice-add-btn__icon"/>
                <span class="notice-add-btn__text">Добавить получателя уведомлений</span>
              </div>
            </ObMenuDropdown>
          </div>
        </div>
      </ObCollapseItem>
    </ObCollapse>
  </SinglePane>
</template>

<script>
import api from '@/api';
import { uuid } from 'vue-uuid';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObCollapse from 'common-components/src/obComponents/obCollapse';
import ObCollapseItem from 'common-components/src/obComponents/obCollapse/collapse-item';
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
import ObFunctionalPanel from 'common-components/src/obComponents/obFuncPanel';
import UserForm from '@/pages/noticePage/UserForm';

export default {
  name: 'NoticePage',
  components: {
    SinglePane,
    ObCollapse,
    ObCollapseItem,
    ObMenuDropdown,
    ObFunctionalPanel,
    UserForm
  },
  data () {
    return {
      systemUsers: [],
      systemUser: true,
      columns: [{
        title: 'Событие',
        slotName: 'event',
        _isEnabled: true
      }],
      notices: [],
      keyWord: ''
    }
  },
  async mounted () {
    this.systemUsers =  await api.users.getUsers();
    this.systemUsers = this.systemUsers.map(value => {
      let _fullName = value.last_name +' '+ value.first_name +' '+ value.patronymic
      value.full_name = _fullName
      return value
    })
    this.systemUsers = this.systemUsers.filter(value => value.is_active)
    this.notices = await api.notice.getNotices();

    try {
      let data = await api.notice.getSettings()
      this.settings = data.map(item => {
       let recipientInfo = item.recipientInfo.filter(info => this.systemUsers.find(user => user.uuid === info.userUuid))
        item.recipientInfo = recipientInfo
        return {
          ...item
          // recipientInfo
        }
      })
    } catch (e) {
      this.settings = []
    }

    this.correctNotice()
  },
  methods: {
    async updateSetting(setting) {
      await api.notice.setSettings(setting);
      this.correctNotice();
    },
    correctNotice() {
      this.notices = this.notices.map(value => {
        let _settings = this.settings;
        _settings = _settings.filter(setting => {
          return setting.notificationTypeUuid === value.uuid
        })
        value.settings = _settings
        // логика счетчика пользователей
        let _counter = [];
        value.settings.forEach( v =>{
          if(!v.uuid){
            v.uuid = uuid.v4()
          }
         v.recipientInfo.forEach(item => {
           _counter.push(item)
         })
        })
        let op = [],
            map = {}, it, item;
        for (let i = 0; i < _counter.length; i++) {
          it = _counter[i];
          item = map[it.userUuid];
          if (item) {
            item.userUuid += it.userUuid;
            if(item.userUuid === 0){
              op.push(item);
            }
          }
         else {
            map[it.userUuid] = item = {userUuid: it.userUuid};
            op.push(item);
          }
        }
        value.counter = op
        return value
      })
    },
    onSearch (word) {
      this.keyWord = word
    },
    addUserForm (index, uuidSettings, settingType) {
      let initSetting = {
              notificationTypeUuid: uuidSettings,
              isActive: true,
              channels: [],
              recipientInfo : [],
              frequencySending: 'ONLINE',
              timeAt: null,
              periodFrom: '00:00+03:00',
              settingType: settingType,
              periodTo: '00:00+03:00'
            };
      this.settings.push(initSetting)
      this.correctNotice()
    },
    onRemoveSettings(item){
      let new_data = [];
      this.settings.forEach(key => {
        if (!Object.is(key, item)) {
          new_data.push(key)
        }
      });
      this.settings = new_data;
      this.correctNotice();
    }
  }
}
</script>

<style lang="scss" scoped>
::v-deep{
  .ob-collapse{
    overflow: visible;
  }
  .ob-collapse__content{
    overflow: visible;
  }
}
.notice {
  .notice-title {
    padding: 15px 64px;
    font-size: 9.5px;
    line-height: 10px;
    letter-spacing: 0.4px;
    text-transform: uppercase;
    color: $shale-gray;
  }
  .notice-add-btn {
    padding-left: 45px;
    &__icon {
      color: $color-grey-span;
      font-size: 16px;
    }
    &__text {
      font-size: 14px;
      color: $color-blue-navy-blue;
      vertical-align: 1px;
    }
  }

  .ob-collapse {
    &-title {
      float: right;
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
      font-weight: normal;
      &._subscriptions {
        color: $color-blue-navy-blue;
      }
      &._recipients {
        color: $gray-slate;
        margin-left: 30px;
      }
    }
  }
}
</style>
